diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRFileWriter.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRFileWriter.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRFileWriter.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRFileWriter.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 2,12 ****
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
! */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
- 
- 
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  
--- 2,10 ----
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
!  */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  
***************
*** 16,46 ****
  import java.util.List;
  import java.util.UUID;
  
- 
- 
  public class RDRFileWriter {
! 	
  	private String tempFilename;
  	private String destPath;
- 	
- 	// private List<RDRProduct> rdrProducts = new LinkedList<RDRProduct>();
  	private RDRCreateFile rdrFile;
- 	
- 	
  	private int orbit;
  	private Origin distributor;
  	private MissionName missionName;
  	private Origin datasetSource;
  	private PlatformShortName platformShortname;
! 	
! 	
! 	public RDRFileWriter(String destPath, 
! 						int orbit, 
! 						int rdrCount, 
! 						Origin distributor, 
! 						MissionName missionName, 
! 						Origin datasetSource, 
! 						PlatformShortName platformShortname) throws RtStpsException {
  		this.distributor = distributor;
  		this.missionName = missionName;
  		this.datasetSource = datasetSource;
--- 14,33 ----
  import java.util.List;
  import java.util.UUID;
  
  public class RDRFileWriter {
! 
  	private String tempFilename;
  	private String destPath;
  	private RDRCreateFile rdrFile;
  	private int orbit;
  	private Origin distributor;
  	private MissionName missionName;
  	private Origin datasetSource;
  	private PlatformShortName platformShortname;
! 
! 	public RDRFileWriter(String destPath, int orbit, int rdrCount,
! 			Origin distributor, MissionName missionName, Origin datasetSource,
! 			PlatformShortName platformShortname) throws RtStpsException {
  		this.distributor = distributor;
  		this.missionName = missionName;
  		this.datasetSource = datasetSource;
***************
*** 48,67 ****
  		this.orbit = orbit;
  		this.destPath = destPath;
  		tempFilename = UUID.randomUUID().toString() + ".h5";
! 			
  		rdrFile = new RDRCreateFile(destPath, tempFilename, rdrCount);
  	}
! 	
! 	
! 	public RDRFileWriter(Stats stats, 
! 			String destPath, 
! 			int orbit, 
! 			int rdrCount, 
! 			Origin distributor, 
! 			MissionName missionName, 
! 			Origin datasetSource, 
  			PlatformShortName platformShortname) throws RtStpsException {
! 		
  		this.distributor = distributor;
  		this.missionName = missionName;
  		this.datasetSource = datasetSource;
--- 35,48 ----
  		this.orbit = orbit;
  		this.destPath = destPath;
  		tempFilename = UUID.randomUUID().toString() + ".h5";
! 
  		rdrFile = new RDRCreateFile(destPath, tempFilename, rdrCount);
  	}
! 
! 	public RDRFileWriter(Stats stats, String destPath, int orbit, int rdrCount,
! 			Origin distributor, MissionName missionName, Origin datasetSource,
  			PlatformShortName platformShortname) throws RtStpsException {
! 
  		this.distributor = distributor;
  		this.missionName = missionName;
  		this.datasetSource = datasetSource;
***************
*** 73,176 ****
  		rdrFile = new RDRCreateFile(stats, destPath, tempFilename, rdrCount);
  	}
  
  
  	public void put(Packet p) throws RtStpsException {
! 		rdrFile.put(p);
  	}
  
! 
  	public void close(boolean hdfCleanup) throws RtStpsException {
! 		
  		Date creationDateAndTime = new Date();
  		// the top level attributes
  		writeAttributes(creationDateAndTime);
! 		
  		// close the rdr file...
  		rdrFile.close();
! 		
  		// clean up any leftover housekeeping
  		if (hdfCleanup) {
  			HDF5Util.cleanup();
  		}
! 		
  		// rename to the final file name
  		rename(creationDateAndTime);
  	}
- 	
- 	private void writeAttributes(Date creationDateAndTime) throws RtStpsException {
  
! 		rdrFile.writeAttributes(creationDateAndTime, distributor, this.missionName, this.datasetSource, platformShortname);
  
! 	}
  
  
  	private void rename(Date creationDateAndTime) throws RtStpsException {
  		File old = new File(destPath, tempFilename);
! 		
  		List<RDR> rdrs = rdrFile.getRDRs();
! 		//PDSDate d1 = rdrFile.getFirstDateTime();
! 		//PDSDate d2 = rdrFile.getLastDataTime();
! 		
  		Aggregate firstAgg = findFirstScienceWeightedAggregate(rdrs);
! 		
! 		// LPEATE seems to want the original data based times not the rounded/truncated times in the file name
! 		PDSDate temp1 = firstAgg.getBeginningDateTime();
! 		PDSDate d1 = new PDSDate(temp1.getOriginalPacketTime());
! 		
! 		//PDSDate temp2 = firstAgg.getEndingDateTime();
! 		//PDSDate d2 = new PDSDate(temp2.getOriginalPacketTime());
! 		
! 		//PDSDate d1 = firstAgg.getBeginningDateTime();
! 		
! 		// But this one is offset from it and so is not really a LPEATE or LeapDate
! 		// it's the same if you get the original time or not in other words.
! 		// That means we have to substract the leap time from it.
! 		PDSDate d2 = firstAgg.getEndingDateTime();
! 		
! 		
! 		
! 		if (rdrs == null) return;
! 		if (rdrs.size() <= 0) return;
! 		if ((d1 == null) || (d2 == null)) return;
! 		
! 		NPOESSFilename nfn = new NPOESSFilename(rdrs,
! 												d1,
! 												d2,
! 												creationDateAndTime,
! 												SpacecraftId.npp,
! 												orbit,
! 												Origin.nfts);
! 		
! 		String realFilename = nfn.toString();
! 		
! 
! 		File nnew = new File(destPath, realFilename);
! 		
! 		old.renameTo(nnew);
! 		
! 		createUserBlock(nnew);
  	}
- 	
  
  	// FIXME only supports either RDRs with "SCIENCE" in the name or the DIARY
! 	private Aggregate findFirstScienceWeightedAggregate(List<RDR> rdrs) throws RtStpsException {
  		List<RDR> sciRDRs = new LinkedList<RDR>();
  		RDR diaryRDR = null;
  		for (RDR rdr : rdrs) {
! 			String rdrNameStr = rdr.getRDRName().getRDRStringName();  // avoid toString w/RDRName
  			if (rdrNameStr.contains("SCIENCE")) {
  				sciRDRs.add(rdr);
  			} else if (rdrNameStr.contains("DIARY")) {
  				diaryRDR = rdr;
  			} else {
! 				throw new RtStpsException("No support for non-science/non-diary RDRs [" + rdrNameStr + "]");
  			}
  		}
! 		
  		if ((sciRDRs.size() <= 0) && (diaryRDR == null)) {
! 			throw new RtStpsException("No science/diary RDRs found -- unable to get first/last time for filename");			
  		}
! 	
  		Aggregate firstAggregate = null;
  		// if there are any science RDRs, use them...
  		if (sciRDRs.size() > 0) {
--- 54,167 ----
  		rdrFile = new RDRCreateFile(stats, destPath, tempFilename, rdrCount);
  	}
  
+ 	public boolean changeGranule(Packet p) throws RtStpsException
+ 	{
+ 		return rdrFile.changeGranule(p);
+ 	}
  
  	public void put(Packet p) throws RtStpsException {
! 		rdrFile.put(p,  false);
  	}
  
! 	
! 	public void put(Packet p, boolean diariesOnly) throws RtStpsException {
! 		rdrFile.put(p,  diariesOnly);
! 	}
! 	
  	public void close(boolean hdfCleanup) throws RtStpsException {
! 
! 		System.out.println("Close file: cleanup: "+hdfCleanup);
  		Date creationDateAndTime = new Date();
  		// the top level attributes
  		writeAttributes(creationDateAndTime);
! 
  		// close the rdr file...
  		rdrFile.close();
! 
  		// clean up any leftover housekeeping
  		if (hdfCleanup) {
  			HDF5Util.cleanup();
  		}
! 
  		// rename to the final file name
  		rename(creationDateAndTime);
  	}
  
! 	private void writeAttributes(Date creationDateAndTime)
! 			throws RtStpsException {
  
! 		rdrFile.writeAttributes(creationDateAndTime, distributor,
! 				this.missionName, this.datasetSource, platformShortname);
  
+ 	}
  
  	private void rename(Date creationDateAndTime) throws RtStpsException {
  		File old = new File(destPath, tempFilename);
! 
  		List<RDR> rdrs = rdrFile.getRDRs();
! 
  		Aggregate firstAgg = findFirstScienceWeightedAggregate(rdrs);
! 
! 		if (firstAgg != null) {
! 
! 			// LPEATE seems to want the original data based times not the
! 			// rounded/truncated times in the file name
! 			PDSDate temp1 = firstAgg.getBeginningDateTime();
! 			PDSDate d1 = new PDSDate(temp1.getOriginalPacketTime());
! 
! 
! 			// But this one is offset from it and so is not really a LPEATE or
! 			// LeapDate
! 			// it's the same if you get the original time or not in other words.
! 			// That means we have to substract the leap time from it.
! 			PDSDate d2 = firstAgg.getEndingDateTime();
! 
! 			if (rdrs == null)
! 				return;
! 			if (rdrs.size() <= 0)
! 				return;
! 			if ((d1 == null) || (d2 == null))
! 				return;
! 
! 			NPOESSFilename nfn = new NPOESSFilename(rdrs, d1, d2,
! 					creationDateAndTime, SpacecraftId.npp, orbit, Origin.nfts);
! 
! 			String realFilename = nfn.toString();
! 
! 			File nnew = new File(destPath, realFilename);
! 
! 			old.renameTo(nnew);
! 
! 			createUserBlock(nnew);
! 		}
  	}
  
  	// FIXME only supports either RDRs with "SCIENCE" in the name or the DIARY
! 	private Aggregate findFirstScienceWeightedAggregate(List<RDR> rdrs)
! 			throws RtStpsException {
  		List<RDR> sciRDRs = new LinkedList<RDR>();
  		RDR diaryRDR = null;
  		for (RDR rdr : rdrs) {
! 			String rdrNameStr = rdr.getRDRName().getRDRStringName(); // avoid
! 																		// toString
! 																		// w/RDRName
  			if (rdrNameStr.contains("SCIENCE")) {
  				sciRDRs.add(rdr);
  			} else if (rdrNameStr.contains("DIARY")) {
  				diaryRDR = rdr;
  			} else {
! 				throw new RtStpsException(
! 						"No support for non-science/non-diary RDRs ["
! 								+ rdrNameStr + "]");
  			}
  		}
! 
  		if ((sciRDRs.size() <= 0) && (diaryRDR == null)) {
! 			System.out.println("No science/diary RDRs found -- unable to get first/last time for filename" );
! 			throw new RtStpsException(
! 					"No science/diary RDRs found -- unable to get first/last time for filename");
  		}
! 
  		Aggregate firstAggregate = null;
  		// if there are any science RDRs, use them...
  		if (sciRDRs.size() > 0) {
***************
*** 181,187 ****
  			// otherwise must be a non-null diary then right?
  			firstAggregate = diaryRDR.getAggregate();
  		}
! 		
  		return firstAggregate;
  	}
  
--- 172,178 ----
  			// otherwise must be a non-null diary then right?
  			firstAggregate = diaryRDR.getAggregate();
  		}
! 
  		return firstAggregate;
  	}
  
***************
*** 189,224 ****
  	private Aggregate findFirstAggregate(List<RDR> rdrs) {
  		Aggregate firstAgg = null;
  		long firstMicros = 0L;
! 		
  		for (RDR rdr : rdrs) {
  			Aggregate agg = rdr.getAggregate();
! 			
! 			long micros = agg.getBeginningDateTime().getMicrosSinceEpoch();
! 			
! 			if (firstMicros == 0L) {
! 				firstMicros = micros;
! 				firstAgg = agg;
! 			} else if (micros < firstMicros) {
! 				firstMicros = micros;
! 				firstAgg = agg;
  			}
  		}
  		return firstAgg;
  	}
  
- 
  	private void createUserBlock(File file) throws RtStpsException {
! 		
  		List<RDR> rdrs = rdrFile.getRDRs();
! 		
! 		if (rdrs == null) return;
! 		
! 		if (rdrs.size() <= 0) return;
! 		
! 		UserBlock userBlock = new UserBlock(MissionName.NPP, PlatformShortName.NPP, rdrs);
! 		
  		userBlock.write(file);
! 		
  		userBlock.close();
  	}
  
--- 180,219 ----
  	private Aggregate findFirstAggregate(List<RDR> rdrs) {
  		Aggregate firstAgg = null;
  		long firstMicros = 0L;
! 
  		for (RDR rdr : rdrs) {
  			Aggregate agg = rdr.getAggregate();
! 			if (agg != null) {
! 
! 				long micros = agg.getBeginningDateTime().getMicrosSinceEpoch();
! 
! 				if (firstMicros == 0L) {
! 					firstMicros = micros;
! 					firstAgg = agg;
! 				} else if (micros < firstMicros) {
! 					firstMicros = micros;
! 					firstAgg = agg;
! 				}
  			}
  		}
  		return firstAgg;
  	}
  
  	private void createUserBlock(File file) throws RtStpsException {
! 
  		List<RDR> rdrs = rdrFile.getRDRs();
! 
! 		if (rdrs == null)
! 			return;
! 
! 		if (rdrs.size() <= 0)
! 			return;
! 
! 		UserBlock userBlock = new UserBlock(MissionName.NPP,
! 				PlatformShortName.NPP, rdrs);
! 
  		userBlock.write(file);
! 
  		userBlock.close();
  	}
  
diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDR.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDR.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDR.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDR.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 69,74 ****
--- 69,87 ----
  	}
  
  	
+ 	public boolean changeGranule(Packet p) throws RtStpsException
+ 	{
+ 		boolean cg=false;
+ 	
+ 		RawApplicationPackets rap = this.getCurrentRawApplicationPackets();
+ 		if ( rap.notFull(p)) {
+ 			
+ 		} else {
+ 			cg = true;
+ 		} 
+ 		return cg;
+ 	}
+ 	
  	/**
  	 * Put a packet into the RDR.
  	 * @param p the Packet of interest
***************
*** 186,192 ****
  		
  		Granule granule = Granule.factory(rap, 
  										1L,
! 										new GranuleId(SpacecraftId.npp, rap.getFirstTime(), 0 /** HACK **/, rap.getTimeSpan()),
  										LEOAFlag.Off,
  										DocumentName ,
  										rap.getPacketTypes(),
--- 199,205 ----
  		
  		Granule granule = Granule.factory(rap, 
  										1L,
! 										new GranuleId(SpacecraftId.npp, rap.getFirstTime(),rdrName),
  										LEOAFlag.Off,
  										DocumentName ,
  										rap.getPacketTypes(),
***************
*** 209,214 ****
--- 222,228 ----
  	 * @throws RtStpsException
  	 */
  	private void finish() throws RtStpsException {
+ 		System.out.println("RDR Finish");
  		RawApplicationPackets rap = this.getCurrentRawApplicationPackets();
  
  		if (rdrAll.write(rap)) {
diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDROutput.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDROutput.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDROutput.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDROutput.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 46,52 ****
      @Override
      public void load(org.w3c.dom.Element element, Configuration configuration) throws RtStpsException
      {
!     	
      	++openCount;
      	
          super.setLinkName(element.getAttribute("label"));
--- 46,52 ----
      @Override
      public void load(org.w3c.dom.Element element, Configuration configuration) throws RtStpsException
      {
!     	System.out.println("RDROutput load");
      	++openCount;
      	
          super.setLinkName(element.getAttribute("label"));
***************
*** 127,142 ****
      	// this seems to be called more than once during the shutdown sequence resulting in an error
      	// so only close everything up one time.  Load resets it.
      	
!     	//System.out.print("Trying to flush link: " + this.getLinkName());
      	if (rdrBuilder != null) {
      		if (openCount <= 1) {
      			
      			rdrBuilder.close(true); // clean up all the HDF
!     			//System.out.println("a Flushed " + this.getLinkName() + " -- closed out HDF");
      		} else {
      			
      			rdrBuilder.close(false);
!     			//System.out.println("a Flushed " + this.getLinkName() + " -- HDF untouched");
      		}
      		openCount--;
      		rdrBuilder = null;  // let the heap reclaim its resources
--- 127,142 ----
      	// this seems to be called more than once during the shutdown sequence resulting in an error
      	// so only close everything up one time.  Load resets it.
      	
!     	System.out.println("Trying to flush link: " + this.getLinkName());
      	if (rdrBuilder != null) {
      		if (openCount <= 1) {
      			
      			rdrBuilder.close(true); // clean up all the HDF
!     			System.out.println("a Flushed " + this.getLinkName() + " -- closed out HDF");
      		} else {
      			
      			rdrBuilder.close(false);
!     			System.out.println("a Flushed " + this.getLinkName() + " -- HDF untouched");
      		}
      		openCount--;
      		rdrBuilder = null;  // let the heap reclaim its resources
diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/SpacecraftDiaryRawApplicationPackets2.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/SpacecraftDiaryRawApplicationPackets2.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/SpacecraftDiaryRawApplicationPackets2.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/SpacecraftDiaryRawApplicationPackets2.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 2,69 ****
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
! */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  import ncsa.hdf.hdf5lib.exceptions.HDF5LibraryException;
  
! public class SpacecraftDiaryRawApplicationPackets2 extends RawApplicationPackets {
  
  	private long firstTime = -1l;
  	private boolean fullGranule = false;
  	private Stats stats = null;
  	private long currentTimeOfGranule = 0l;
  
! 	public SpacecraftDiaryRawApplicationPackets2(SpacecraftId satellite, int setNum, PacketPool packetPool) {
! 		super(satellite,  RDRName.NPP_Ephemeris_and_Attitude, setNum, packetPool);
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
  	}
! 	
! 	public SpacecraftDiaryRawApplicationPackets2(Stats stats, SpacecraftId satellite, int setNum, PacketPool packetPool) {
! 		super(satellite,  RDRName.NPP_Ephemeris_and_Attitude, setNum, packetPool);
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
  		this.stats = stats;
  	}
! 	
  	/**
! 	 * Constructor which attempts to read the RawApplicationPacket entry that pre-exists.
! 	 * The contents of the dataspace are read into a memory buffer... assuming it will fit.
! 	 * @param allRDRId  the rdrAll Groups id
! 	 * @param setNum the set number of raw entry
! 	 * @throws NullPointerException 
! 	 * @throws HDF5LibraryException 
! 	 * @throws RtStpsException 
  	 */
! 	public SpacecraftDiaryRawApplicationPackets2(int allRDRId, int setNum) throws RtStpsException {
  		super(allRDRId, setNum);
  	}
! 	
! 	public SpacecraftDiaryRawApplicationPackets2(int readId, int setNum, boolean usedByGranuleOnly) throws RtStpsException {
  		super(readId, setNum, true);
  	}
  
  
! 	@Override
  	public boolean notFull(Packet p) throws RtStpsException {
  		boolean notFull = true;
! 		//System.out.println("S/C APID:"+p.getApplicationId()+":"+p.getTimeStamp(8));
! 		if (p.getApplicationId() == 11) {  // idea is we allow apid=0 and 8 in but only check for fullness on apid=11
! 			long timestamp = p.getTimeStamp(8);
  			if (this.firstTime < 0l) {
  				this.firstTime = timestamp;
  			} else {
! 				
! 				if (greaterThanEqualTo(timestamp, firstTime, 20)) {
! 					notFull = false;  // if 20secs have gone by, the granule is full
  					fullGranule = true;
  				}
  			}
  		}
  		return notFull;
  	}
--- 2,151 ----
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
!  */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  import ncsa.hdf.hdf5lib.exceptions.HDF5LibraryException;
  
! public class SpacecraftDiaryRawApplicationPackets2 extends
! 		RawApplicationPackets {
  
  	private long firstTime = -1l;
  	private boolean fullGranule = false;
  	private Stats stats = null;
  	private long currentTimeOfGranule = 0l;
  
! 	public SpacecraftDiaryRawApplicationPackets2(SpacecraftId satellite,
! 			int setNum, PacketPool packetPool) {
! 		super(satellite, RDRName.NPP_Ephemeris_and_Attitude, setNum, packetPool);
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
  	}
! 
! 	public SpacecraftDiaryRawApplicationPackets2(Stats stats,
! 			SpacecraftId satellite, int setNum, PacketPool packetPool) {
! 		super(satellite, RDRName.NPP_Ephemeris_and_Attitude, setNum, packetPool);
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
  		this.stats = stats;
  	}
! 
  	/**
! 	 * Constructor which attempts to read the RawApplicationPacket entry that
! 	 * pre-exists. The contents of the dataspace are read into a memory
! 	 * buffer... assuming it will fit.
! 	 * 
! 	 * @param allRDRId
! 	 *            the rdrAll Groups id
! 	 * @param setNum
! 	 *            the set number of raw entry
! 	 * @throws NullPointerException
! 	 * @throws HDF5LibraryException
! 	 * @throws RtStpsException
  	 */
! 	public SpacecraftDiaryRawApplicationPackets2(int allRDRId, int setNum)
! 			throws RtStpsException {
  		super(allRDRId, setNum);
  	}
! 
! 	public SpacecraftDiaryRawApplicationPackets2(int readId, int setNum,
! 			boolean usedByGranuleOnly) throws RtStpsException {
  		super(readId, setNum, true);
  	}
  
+ 	// @Override
+ 	// public boolean notFull(Packet p) throws RtStpsException {
+ 	// boolean notFull = true;
+ 	// //System.out.println("S/C APID:"+p.getApplicationId()+":"+p.getTimeStamp(8));
+ 	// if (p.getApplicationId() == 11) { // idea is we allow apid=0 and 8 in but
+ 	// only check for fullness on apid=11
+ 	// long timestamp = p.getTimeStamp(8);
+ 	// if (this.firstTime < 0l) {
+ 	// this.firstTime = timestamp;
+ 	// } else {
+ 	//
+ 	// if (greaterThanEqualTo(timestamp, firstTime, 20)) {
+ 	// notFull = false; // if 20secs have gone by, the granule is full
+ 	// fullGranule = true;
+ 	// }
+ 	// }
+ 	// }
+ 	// return notFull;
+ 	// }
  
! 	// static long firstTime = -1;
! 
! 	/**
! 	 * Granules are created from scans. Scans in VIIRS are lots of packets the
! 	 * first 800 w/with a secondaryheader is used here to signal the start of a
! 	 * scan. We collect it and everything after it as one scan until it
! 	 * re-appears. Anything more complex than this can be built on top of this
! 	 * one assumption.
! 	 * 
! 	 * @param p
! 	 *            a Packet to be put into the VIIRS RawApplicationPackets area
! 	 * @return true if it can be put there, or false if it is full and should be
! 	 *         written to disk first
! 	 * @exception wraps
! 	 *                any HDF exceptions in RtStpsException
! 	 */
  	public boolean notFull(Packet p) throws RtStpsException {
+ 
  		boolean notFull = true;
! 		// System.out.println("S/C APID:"+p.getApplicationId()+":"+p.getTimeStamp(8));
! 
! 		long timestamp = p.getTimeStamp(8);
! 
! 		GranuleId currentGranId = new GranuleId(SpacecraftId.npp,
! 				p.getTimeStamp(8), RDRName.NPP_Ephemeris_and_Attitude);
! 
! 		LeapDate obsTime = new LeapDate(timestamp);
! 		// System.out.printf("VIIRS: Gran %s seq %d ts %d obs %d \n",
! 		// currentGranId.toString(), p.getSequenceCounter(),
! 		// timestamp, obsTime.getMicrosSinceEpoch());
! 
! 		if (currentGranId.toString().startsWith("NPP-") == false) {
! 
  			if (this.firstTime < 0l) {
  				this.firstTime = timestamp;
+ 				setFirstTime(timestamp);
+ 				System.out.println("DIARY first packid: "+p.getSequenceCounter());
  			} else {
! 				GranuleId startGranId = new GranuleId(SpacecraftId.npp,
! 						getFirstTime(), RDRName.NPP_Ephemeris_and_Attitude);
! 
! 				LeapDate startObs = new LeapDate(getFirstTime()); // srm
! 
! 				LeapDate lpd = new LeapDate(getFirstTime());
! 				long ietTimeThis = lpd.getMicrosSinceEpoch();
! 				long stThis = GranuleId.calcGranuleStartTime(ietTimeThis,
! 						RDRName.NPP_Ephemeris_and_Attitude);
! 
! 				lpd = new LeapDate(p.getTimeStamp(8));
! 				long ietTimeNext = lpd.getMicrosSinceEpoch();
! 				long stNext = GranuleId.calcGranuleStartTime(ietTimeNext,
! 						RDRName.NPP_Ephemeris_and_Attitude);
! 
! 				// System.out.printf(
! 				// "DIARY ietthis: %d start: %d Next %d %d\n",
! 				// ietTimeThis, stThis, ietTimeNext, stNext);
! 
! 				if (stThis != stNext) {
! //					System.out.println("GRAN DIARY: " + startGranId.toString()+ " Current:" + currentGranId.toString()+" packid: "+p.getSequenceCounter()+" APID:"+p.getApplicationId());
! 					System.out.printf("GRAN DIARY: %s Current: %s  packid: %d APID:%d \n",startGranId.toString(),currentGranId.toString(),p.getSequenceCounter(),p.getApplicationId());
! 
! 					notFull = false; // if 20secs have gone by, the granule
! 										// is full
  					fullGranule = true;
+ 
  				}
+ 
  			}
+ 
  		}
  		return notFull;
  	}
***************
*** 71,167 ****
  	@Override
  	public void put(Packet p) throws RtStpsException {
  		this.updateAppIdCounters(p.getApplicationId());
- 		
- 		if (p.getApplicationId() == 11) {// idea is we allow apid=0 and 8 in but only check for fullness on apid=11
  
! 			// secondary time stamp only valid in in first or standalone packets...
  			if (getFirstTime() == 0L) {
! 				//System.out.println("Here...");
  				setFirstTime(p.getTimeStamp(8));
  			}
! 			
  			setLastTime(p.getTimeStamp(8));
  		}
! 		
  		// the packet is deep copied, it is allocated off a pool
! 		// which may hold previously copied packets...  they must be put
  		// back on the pool when done...
! 		
  		Packet pcopy = CopyPacket.deep(p, packetPool);
! 		
  		getPacketList().add(pcopy);
  	}
! 	
  	/**
! 	 * Write the collected group of packets to the designated HDF file using the handle
  	 * @return true if the RawApplicationPacket was written, false if not
! 	 * @exception any HDF exceptions are wrapped in an RtStpsException
  	 */
  	public boolean write(int hdfFile) throws RtStpsException {
  		boolean ret = true;
  		if (fullGranule == true) {
! 			
! 			
  			if (stats == null) {
! 				System.out.println("Creating Spacecraft Diary Granule -- [" + 20 + "] seconds"); // FIXME do we show them the real time or the near time?
  			} else {
  				stats.ae_createdGranules.value++;
  			}
! 			
  			ret = super.write(hdfFile);
! 			
! 			
  		} else {
! 			
  			if (stats == null) {
! 				double time = currentTimeOfGranule/1000000.0;
! 				System.out.println("Creating Partial Spacecraft Diary Granule -- [" + time + "] seconds");
  			} else {
  				stats.ae_createdGranules.value++;
  			}
! 			
  			ret = super.write(hdfFile);
  		}
! 		
  		fullGranule = false;
  		this.firstTime = -1l;
! 		
  		return ret;
  	}
! 	
  	/**
! 	 * Close out the RawApplicationPacket which writes the results to the HDF file and cleans up.
! 	 * @exception any HDF exceptions are wrapped in an RtStpsException
  	 */
  	public void close() throws RtStpsException {
  		super.close();
! 		this.firstTime = -1L; 
  		fullGranule = false;
  	}
! 	
  	// see if time between current time and old time is X seconds or more
! 	public boolean greaterThanEqualTo(long timeStamp1, long timeStamp2, int seconds) {
! 		
  		long rawDay1 = (timeStamp1 >> 48) & 0x0ffffL;
  		long rawMillis1 = (timeStamp1 >> 16) & 0x0ffffffffL;
  		long rawMicros1 = timeStamp1 & 0x0ffffL;
! 		
  		long micros1 = 86400000000l * rawDay1;
  		micros1 += rawMillis1 * 1000l;
  		micros1 += rawMicros1;
! 		
  		long rawDay2 = (timeStamp2 >> 48) & 0x0ffffL;
  		long rawMillis2 = (timeStamp2 >> 16) & 0x0ffffffffL;
  		long rawMicros2 = timeStamp2 & 0x0ffffL;
! 		
  		long micros2 = 86400000000l * rawDay2;
  		micros2 += rawMillis2 * 1000l;
  		micros2 += rawMicros2;
! 		
  		currentTimeOfGranule = micros1 - micros2;
! 		
! 		long tmp2 = (long)seconds * 1000000l;
  		return (currentTimeOfGranule >= tmp2);
  	}
! 	
  }
--- 153,261 ----
  	@Override
  	public void put(Packet p) throws RtStpsException {
  		this.updateAppIdCounters(p.getApplicationId());
  
! 		if (p.getApplicationId() == 11) {// idea is we allow apid=0 and 8 in but
! 											// only check for fullness on
! 											// apid=11
! 
! 			// secondary time stamp only valid in in first or standalone
! 			// packets...
  			if (getFirstTime() == 0L) {
! 				// System.out.println("Here...");
  				setFirstTime(p.getTimeStamp(8));
  			}
! 
  			setLastTime(p.getTimeStamp(8));
  		}
! 
  		// the packet is deep copied, it is allocated off a pool
! 		// which may hold previously copied packets... they must be put
  		// back on the pool when done...
! 
  		Packet pcopy = CopyPacket.deep(p, packetPool);
! 
  		getPacketList().add(pcopy);
  	}
! 
  	/**
! 	 * Write the collected group of packets to the designated HDF file using the
! 	 * handle
! 	 * 
  	 * @return true if the RawApplicationPacket was written, false if not
! 	 * @exception any
! 	 *                HDF exceptions are wrapped in an RtStpsException
  	 */
  	public boolean write(int hdfFile) throws RtStpsException {
  		boolean ret = true;
  		if (fullGranule == true) {
! 
  			if (stats == null) {
! 				System.out.println("Creating Spacecraft Diary Granule -- ["
! 						+ 20 + "] seconds"); // FIXME do we show them the real
! 												// time or the near time?
  			} else {
  				stats.ae_createdGranules.value++;
  			}
! 
  			ret = super.write(hdfFile);
! 
  		} else {
! 
  			if (stats == null) {
! 				double time = currentTimeOfGranule / 1000000.0;
! 				System.out
! 						.println("Creating Partial Spacecraft Diary Granule -- ["
! 								+ time + "] seconds");
  			} else {
  				stats.ae_createdGranules.value++;
  			}
! 
  			ret = super.write(hdfFile);
  		}
! 
  		fullGranule = false;
  		this.firstTime = -1l;
! 
  		return ret;
  	}
! 
  	/**
! 	 * Close out the RawApplicationPacket which writes the results to the HDF
! 	 * file and cleans up.
! 	 * 
! 	 * @exception any
! 	 *                HDF exceptions are wrapped in an RtStpsException
  	 */
  	public void close() throws RtStpsException {
  		super.close();
! 		this.firstTime = -1L;
  		fullGranule = false;
  	}
! 
  	// see if time between current time and old time is X seconds or more
! 	public boolean greaterThanEqualTo(long timeStamp1, long timeStamp2,
! 			int seconds) {
! 
  		long rawDay1 = (timeStamp1 >> 48) & 0x0ffffL;
  		long rawMillis1 = (timeStamp1 >> 16) & 0x0ffffffffL;
  		long rawMicros1 = timeStamp1 & 0x0ffffL;
! 
  		long micros1 = 86400000000l * rawDay1;
  		micros1 += rawMillis1 * 1000l;
  		micros1 += rawMicros1;
! 
  		long rawDay2 = (timeStamp2 >> 48) & 0x0ffffL;
  		long rawMillis2 = (timeStamp2 >> 16) & 0x0ffffffffL;
  		long rawMicros2 = timeStamp2 & 0x0ffffL;
! 
  		long micros2 = 86400000000l * rawDay2;
  		micros2 += rawMillis2 * 1000l;
  		micros2 += rawMicros2;
! 
  		currentTimeOfGranule = micros1 - micros2;
! 
! 		long tmp2 = (long) seconds * 1000000l;
  		return (currentTimeOfGranule >= tmp2);
  	}
! 
  }
